        .586p
        .model  flat,stdcall
        locals
        jumps


UNICODE =       0
        include w32.inc                 ; Very usefull include file

.data

ofn_struc       OPENFILENAME    <>
ofn_filter      db      'Executable file',00h,'*.exe',00h,00h
ofn_title       db      'Select file to unpack',00h
f_name          db      200h dup(?)
f_handle        dd      ?
f_size          dd      ?
read_len        dd      ?
write_len       dd      ?

outfname        db      'out.exe',00h

buffer          dd      ?

pe_header_ptr   dd      ?
sections_start  dd      ?
entry_addr      dd      ?
image_base      dd      ?
section_size    dd      ?

decrypt_byte	db	?

; Messages
error_caption   db      'Error!',00h
cant_open_err   db      'Cannot open input file!',00h
no_mem_err      db      'Cannot allocate memory!',00h
not_mz_err      db      'Not valid EXE file (''MZ'' signature does not present)!',00h
not_pe_err      db      'Not valid PE file (''PE'' signature does not present)!',00h
success_msg     db      'File successfully unpacked!',00h

.code

start   proc
; Prepare the OpenFileName structure and get file name
        mov     ofn_struc.on_lStructSize,OPENFILENAME_
        mov     ofn_struc.on_lpstrFilter,offset ofn_filter
        mov     ofn_struc.on_lpstrFile,offset f_name
        mov     ofn_struc.on_lpstrTitle,offset ofn_title
        mov     ofn_struc.on_nMaxFile,0200h
        mov     ofn_struc.on_Flags,OFN_FILEMUSTEXIST or \
                                   OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                                   OFN_EXPLORER or OFN_HIDEREADONLY
        call    GetOpenFileNameA, offset ofn_struc
        or      eax,eax                 ; Nothing selected?
        jz      exit                    ; If so - exit

        call    CreateFileA, offset f_name, GENERIC_READ+GENERIC_WRITE,\
                             NULL,NULL,\
                             OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
        cmp     eax,INVALID_HANDLE_VALUE
        jne     open_ok

        call    MessageBoxA, NULL, offset cant_open_err, offset error_caption, NULL
        jmp     exit

;------ File is opened OK
open_ok:
        mov     f_handle,eax

;------ Load file in memory
        call    GetFileSize, f_handle, 00h
        mov     f_size,eax

        call    GlobalAlloc, GMEM_FIXED, f_size ; Allocate memory
        or      eax,eax
        jnz     mem_alloc_ok

	call	CloseHandle, f_handle
        call    MessageBoxA, NULL, offset no_mem_err, offset error_caption, NULL
        jmp     exit

;------ Memory allocated OK
mem_alloc_ok:
        mov     buffer,eax

        call    ReadFile, f_handle, buffer, f_size, offset read_len, NULL

	call	CloseHandle, f_handle

;------ Check for valid EXE file
check_valid_exe:
        mov     edx,buffer              ; EDI points to read buffer
        cmp     word ptr [edx],'MZ'
        jz      exe_ok
        cmp     word ptr [edx],'ZM'
        jz      exe_ok

        call    MessageBoxA, NULL, offset not_mz_err, offset error_caption, NULL
        jmp     free_mem_exit

exe_ok:
;------ Check for valid PE file
        add     edx,dword ptr [edx+003ch]       ; EDX -> PE header
        cmp     word ptr [edx],'EP'             ; PE file?
        jz      pe_ok

        call    MessageBoxA, NULL, offset not_pe_err, offset error_caption, NULL
        jmp     free_mem_exit

pe_ok:
        mov     pe_header_ptr,edx

        mov     eax,dword ptr [edx+0034h]       ; Get image base and save it for later use
        mov     image_base,eax                  ;

;###### UNPACKING START ##############################################

        .radix  16d                             ; Too many hex values

unpack_one_layer:
        mov     eax,dword ptr [edx+0028h]       ; EAX points to entry point of program
        call    rva2fo
	or	eax,eax
	jz	free_mem_exit

	mov	ebp,eax

; Check for yoda's crypt 1.0
	cmp	dword ptr [ebp+0006h],0e7ed815dh
	jne	free_mem_exit
	cmp	dword ptr [ebp+000ah],0e800401ah
	jne	free_mem_exit
	cmp	dword ptr [ebp+000eh],000000a1h
	jne	free_mem_exit

;----- Decrypt sections
	mov	al,byte ptr [ebp+042eh]
	mov	decrypt_byte,al
	xor	ebx,ebx			; Decrypt using file offset
	call	decrypt_sections

;----- Set OEP and imports address
	mov	esi,pe_header_ptr

	mov	eax,dword ptr [ebp+00437h]
	mov	dword ptr [esi+0028h],eax

	mov	eax,dword ptr [ebp+0043bh]
	mov	dword ptr [esi+0080h],eax

;----- Remove yoda's crypt section
	dec	word ptr [esi+0006h]		; Decrease number of sections
	sub	dword ptr [esi+0050h],1000h	; Correct image size (a must for NT/2k)
	sub	f_size,0547h			; Reduce write size

;----- Find end of sections
        movzx	eax,word ptr [esi+0006h]
        mov	ebx,0028h
        mul	ebx
        movzx	ebx,word ptr [esi+0014h]
        add	esi,ebx
        add	esi,eax
	add	esi,0018h
	
	mov	edi,esi
;----- Clear yC section header (unused in the decrypted file)
	mov	ecx,0028h
	xor	al,al
	rep	stosb

;###### Write unpacked file to disk ##################################
write_file:
        call    CreateFileA, offset outfname, GENERIC_WRITE,\
                             NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
        push    eax
        call    WriteFile, eax, buffer, f_size, offset write_len, NULL
        call    CloseHandle

free_mem_exit:
        call    GlobalFree,buffer

exit:
        call    ExitProcess, NULL       ; Exit program
start   endp


; Convert RVA in EAX to file offset in EAX. Return NULL if bad RVA!!!
; [section          ][gap][section]	<- File loaded by OS view
;        |-----------------|		<- Decrypt length
; [section          ][section]		<- File layout (as on disk/loaded by unpacker)
;
; if (rva > section_start + section length) and (rva < next_section_start) then EAX=0
rva2fo  proc
        uses    ecx,esi,edi

        mov     esi,pe_header_ptr       ; ESI points to PE header in memory
        movzx   ecx,word ptr [esi+0006h]; ECX=sections number

        movzx   edi,word ptr [esi+14h]  ; Get PE Header Size
        add     edi,18h                 ; Add offset of Flags field
        add     edi,esi                 ; Make EDI = Object Table Address
        mov     sections_start,edi      ; Save for later use

        mov     esi,edi
@@scan_section:
        cmp     eax,dword ptr [esi+000ch]; Compare RVA with section RVA
        jae     @@sect_found

@@go_scan_next_section:
        add     esi,0028h               ; ESI points to next section in memory
        loop    @@scan_section
	jmp	@@wrong_rva

@@sect_found:
	cmp	ecx,0001h
	je	@@its_last_section
	cmp	eax,dword ptr [esi+000ch+0028h]	; Compare with the start RVA of next section
	jae	@@go_scan_next_section

        mov     edi,dword ptr [esi+000ch]; EDI is section start RVA
        add     edi,dword ptr [esi+0010h]; EDI is the end RVA of the section in file
	cmp	eax,edi
	jae	@@wrong_rva


@@its_last_section:
        sub     eax,dword ptr [esi+000ch]; EAX is offset withing section
        add     eax,dword ptr [esi+0014h]; EAX=physical address of section + offset
        add     eax,buffer              ; EAX is offset in our memory buffer!
        ret

@@wrong_rva:
	xor	eax,eax
	ret
rva2fo  endp

.radix	16d
; Decrypt sections
decrypt_sections	proc
	mov	esi,sections_start
	mov	edi,pe_header_ptr
	movzx	edx, word ptr [edi+06]		; DX=number of sections
	dec	edx
	jz	ds_exit
ds_1:
        cmp dword ptr [esi], 63727372h
        jne ds_2
        jmp ds_15

ds_2:
        cmp dword ptr [esi], 7273722Eh
        jne ds_3
        jmp ds_15

ds_3:
        cmp dword ptr [esi], 6F6C6572h
        jne ds_4
        jmp ds_15

ds_4:
        cmp dword ptr [esi], 6C65722Eh
        jne ds_5
        jmp ds_15

ds_5:
        cmp dword ptr [esi], 00004379h
        jne ds_7
        jmp ds_15

ds_7:
        cmp dword ptr [esi], 736C742Eh
        jne ds_8
        jmp ds_15

ds_8:
        cmp dword ptr [esi], 6164652Eh
        jne ds_9
        jmp ds_15

ds_9:
        cmp dword ptr [esi], 6164722Eh
        jne ds_10
        jmp ds_15

ds_10:
        cmp dword ptr [esi+14h], 00000000h
        jne ds_11
        jmp ds_15

ds_11:
        cmp dword ptr [esi+10h], 00000000
        jne ds_12
        jmp ds_15

ds_12:
        pushad
        mov ecx, dword ptr [esi+10h]	; Get physical size of section
;        or ebx, ebx
;        jne ds_13
        mov eax, dword ptr [esi+000ch]	; Get file offset of section
	call rva2fo
	mov esi,eax

        jmp ds_14

ds_13:
        mov esi, dword ptr [esi+0Ch]	; ESI is RVA of section

ds_14:
        call decrypt_single		; Decrypt section in memory
        popad

ds_15:
        add	esi, 00000028h
        dec	edx
        jne	ds_1
ds_exit:
        ret
decrypt_sections	endp

;
; Decrypt section in memory
;

decrypt_single:
        mov edi, esi
ds_loop:
        lodsb
        xor al, decrypt_byte
        stosb
        loop ds_loop
        ret



        end     start
